<?php

namespace App\Http\Controllers;

use App\Models\Bug;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\Request;

class BugController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index(): JsonResponse
    {
        $items = Bug::all();

        return response()->json([
            'success' => true,
            'data' => $items,
            'message' => 'Registros obtenidos correctamente',
        ], 200);
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request): JsonResponse
    {
        $payload = $request->only((new Bug())->getFillable());
        $bug = Bug::create($payload);

        return response()->json([
            'success' => true,
            'data' => $bug,
            'message' => 'Registro creado correctamente',
        ], 201);
    }

    /**
     * Display the specified resource.
     */
    public function show(Bug $bug): JsonResponse
    {
        return response()->json([
            'success' => true,
            'data' => $bug,
            'message' => 'Registro obtenido correctamente',
        ], 200);
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, Bug $bug): JsonResponse
    {
        $payload = $request->only((new Bug())->getFillable());
        $bug->update($payload);

        return response()->json([
            'success' => true,
            'data' => $bug,
            'message' => 'Registro actualizado correctamente',
        ], 200);
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(Bug $bug): JsonResponse
    {
        $bug->delete();

        return response()->json([
            'success' => true,
            'message' => 'Registro eliminado correctamente',
        ], 200);
    }
}